Index: main/plugin-admin/resources/js/Ametys/plugins/admin/datasource/DataSourceTool.js
===================================================================
--- main/plugin-admin/resources/js/Ametys/plugins/admin/datasource/DataSourceTool.js	(revision 0)
+++ main/plugin-admin/resources/js/Ametys/plugins/admin/datasource/DataSourceTool.js	(revision 0)
@@ -0,0 +1,282 @@
+/*
+ *  Copyright 2015 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+
+/**
+ * This tool displays the list of data sources 
+ * @private
+ */
+Ext.define('Ametys.plugins.admin.datasource.DataSourceTool', {
+	extend: 'Ametys.tool.Tool',
+	
+	/**
+	 * @private
+	 * @property {Ext.grid.panel} _panel the data sources' grid panel
+	 */
+	
+	getMBSelectionInteraction: function() 
+	{
+		return Ametys.tool.Tool.MB_TYPE_ACTIVE;
+	},
+	
+	constructor: function(config)
+	{
+		this.callParent(arguments);
+		
+		// Bus messages listeners
+		Ametys.message.MessageBus.on(Ametys.message.Message.CREATED, this._onCreated, this);
+		Ametys.message.MessageBus.on(Ametys.message.Message.MODIFIED, this._onModified, this);
+		Ametys.message.MessageBus.on(Ametys.message.Message.DELETED, this._onDeleted, this);
+	},
+	
+	createPanel: function()
+	{
+		var store = Ext.create('Ext.data.Store', {
+			model: 'Ametys.plugins.admin.datasource.DataSourceTool.DataSource',
+	        groupField: 'type',
+			
+			autoLoad: true,
+			sortOnLoad: true,
+			
+	        proxy: {
+	        	type: 'ametys',
+				plugin: 'admin',
+				url: 'datasources/get',
+	        	reader: {
+	        		type: 'json',
+					rootProperty: 'datasources'
+	        	}
+	        }
+		});
+		
+		this._panel = Ext.create('Ext.grid.Panel', {
+			stateful: true,
+			stateId: this.self.getName() + "$grid",
+
+			store : store,
+			
+			selModel : {
+		    	mode: 'MULTI'
+		    },
+		    
+		    listeners: {
+		    	'selectionchange': {fn: this.sendCurrentSelection, scope: this}
+		    },
+		    
+		    features: [{
+		    	ftype: 'grouping',
+		        groupHeaderTpl: Ext.create('Ext.XTemplate',
+		            '<div>{name:this.formatName}</div>',
+	        	    {
+			        	formatName: function(name)
+				        {
+				        	switch (name)
+				        	{
+					        	case 'SQL':
+					        		return "<i18n:text i18n:key='PLUGINS_ADMIN_UITOOL_DATASOURCE_GROUP_SQL'/>";
+					        		
+					        	case 'LDAP':
+					        		return "<i18n:text i18n:key='PLUGINS_ADMIN_UITOOL_DATASOURCE_GROUP_LDAP'/>";
+					        	default:
+					        		throw 'Unrecognized type ' + name;
+				        	}
+				        }
+	        	    }
+	        	)
+		    }],
+			
+		    columns: [
+		        {stateId: 'grid-name', header: "<i18n:text i18n:key='PLUGINS_ADMIN_UITOOL_DATASOURCE_COL_NAME'/>", flex: 0.8, sortable: true, dataIndex:'name', renderer: this._renderName},
+		        {stateId: 'grid-private', header: "<i18n:text i18n:key='PLUGINS_ADMIN_UITOOL_DATASOURCE_COL_PRIVATE'/>", width: 60, sortable: true, dataIndex: 'private', renderer: this._renderBoolean},
+		        {stateId: 'grid-inUse', header: "<i18n:text i18n:key='PLUGINS_ADMIN_UITOOL_DATASOURCE_COL_USED'/>", width: 60, sortable: true, dataIndex: 'inUse', align :'center', renderer: this._renderBoolean},
+		        {stateId: 'grid-type', header: "<i18n:text i18n:key='PLUGINS_ADMIN_UITOOL_DATASOURCE_COL_TYPE'/>", width: 80, hidden: true, dataIndex: 'type'},
+		        {stateId: 'grid-id', header: "<i18n:text i18n:key='PLUGINS_ADMIN_UITOOL_DATASOURCE_COL_ID'/>", flex: 0.2, hidden: true, dataIndex: 'id'}
+		    ]
+		});
+		
+		return this._panel;
+	},
+	
+	sendCurrentSelection: function()
+	{
+		var targets = [];
+
+		var selectedDataSources = this._panel.getSelectionModel().getSelection();
+		Ext.Array.forEach(selectedDataSources, function(selectedDataSource) {
+			
+			target = Ext.create('Ametys.message.MessageTarget', {
+				type: Ametys.message.MessageTarget.DATASOURCE,
+				parameters: {
+					id: selectedDataSource.get('id'),
+					type: selectedDataSource.get('type'),
+					inUse: selectedDataSource.get('inUse')
+				}
+			});
+			
+			targets.push(target);
+		});
+		
+		Ext.create('Ametys.message.Message', {
+			type: Ametys.message.Message.SELECTION_CHANGED,
+			targets: targets
+		});
+	},
+	
+	/**
+	 * Renderer function for the name column
+	 * @param {String} value the value of the name
+	 * @param {Object} md the metadata of the selected cell
+	 * @param {Ext.data.Model} record The record for the current row
+	 * @return {String} the html representation of the name with an icon
+	 */
+	_renderName: function(value, md, record)
+	{
+		switch (record.get('type'))
+		{
+			case 'SQL':
+				return record.get('private') ? '<span><img src="' + Ametys.getPluginResourcesPrefix('admin') + '/img/datasource/sql_private_16.png" title="' + "<i18n:text i18n:key='PLUGINS_ADMIN_UITOOL_DATASOURCE_SQL_PRIVATE'/>" + '"/> ' + value + '</span>'
+											 : '<span><img src="' + Ametys.getPluginResourcesPrefix('admin') + '/img/datasource/sql_16.png" title="' + "<i18n:text i18n:key='PLUGINS_ADMIN_UITOOL_DATASOURCE_SQL_PUBLIC'/>" + '"/> ' + value + '</span>';
+			case 'LDAP':
+				return record.get('private') ? '<span><img src="' + Ametys.getPluginResourcesPrefix('admin') + '/img/datasource/ldap_private_16.png" title="' + "<i18n:text i18n:key='PLUGINS_ADMIN_UITOOL_DATASOURCE_LDAP_PRIVATE'/>" + '"/> ' + value + '</span>'
+						 : '<span><img src="' + Ametys.getPluginResourcesPrefix('admin') + '/img/datasource/ldap_16.png" title="' + "<i18n:text i18n:key='PLUGINS_ADMIN_UITOOL_DATASOURCE_LDAP_PUBLIC'/>" + '"/> ' + value + '</span>';
+			default:
+				throw 'Unrecognized type ' + record.get('type');
+		}
+	},
+	
+    /**
+     * @private
+     * Renderer function for a boolean
+     * @param {String|Boolean} value the restricted value
+     * @return {String} the html representation of the boolean as an icon.
+     */
+    _renderBoolean: function(value)
+    {
+        if (value == 'true' || (Ext.isBoolean(value) && value))
+        {
+            return '<img src="' + Ametys.getPluginResourcesPrefix('admin') + '/img/datasource/yes_16.png" title="' + "<i18n:text i18n:key='PLUGINS_ADMIN_UITOOL_DATASOURCE_COL_BOOLEAN_YES'/>" + '"/>'
+        }
+        else
+        {
+            return "";
+        }
+    },
+	
+	/**
+	 * Handler function invoked whenever a {@link Ametys.message.Message.CREATED} message is sent out on the 
+	 * message bus. Add the corresponding record to the grid panel's store.
+	 * @param {Ametys.message.Message} message the message
+	 */
+	_onCreated: function(message)
+	{
+		var target = message.getTarget(Ametys.message.MessageTarget.DATASOURCE);
+		if (target)
+		{
+			var id = target.getParameters().id;
+			switch (target.getParameters().type)
+			{
+				case 'SQL':
+					Ametys.plugins.admin.datasource.DataSourceDAO.getSQLDataSource([id], this._addDataSource, {scope: this});
+					break;
+					
+				case 'LDAP':
+					Ametys.plugins.admin.datasource.DataSourceDAO.getLDAPDataSource([id], this._addDataSource, {scope: this});
+					break;
+					
+				default:
+					throw 'Unrecognized datasource type : ' + target.getParameters().type
+			}
+			
+		}
+	},
+	
+ 	/**
+ 	 * Add the created data source to the store
+ 	 * @param {Object} datasource the data source
+ 	 */
+	_addDataSource: function(datasource)
+	{
+		var record = Ext.create('Ametys.plugins.admin.datasource.DataSourceTool.DataSource', datasource);
+		this._panel.getStore().addSorted(record);
+	},
+	
+	/**
+	 * Handler function invoked whenever a {@link Ametys.message.Message.MODIFIED} message is sent out on the 
+	 * message bus. Update the corresponding record of the grid panel's store.
+	 * @param {Ametys.message.Message} message the message
+	 */
+	_onModified: function (message)
+	{
+		var target = message.getTarget(Ametys.message.MessageTarget.DATASOURCE);
+		if (target)
+		{
+			var id = target.getParameters().id;
+			switch (target.getParameters().type)
+			{
+				case 'SQL':
+					Ametys.plugins.admin.datasource.DataSourceDAO.getSQLDataSource([id], Ext.bind(this._editDataSource, this, [id], 1), {scope: this});
+					break;
+					
+				case 'LDAP':
+					Ametys.plugins.admin.datasource.DataSourceDAO.getLDAPDataSource([id], Ext.bind(this._editDataSource, this, [id], 1), {scope: this});
+					break;
+					
+				default:
+					throw 'Unrecognized datasource type : ' + target.getParameters().type
+			}
+			
+		}
+	},
+	
+ 	/**
+ 	 * Edit the modified data source
+ 	 * @param {Object} datasource the data source
+ 	 */
+	_editDataSource: function(datasource, id)
+	{
+		var store = this._panel.getStore();
+		
+		var record = store.getById(id);
+		
+		record.beginEdit();
+		record.set('name', datasource.name);
+		record.set('inUse', datasource.inUse);
+		record.set('private', datasource['private']);
+		record.endEdit();
+		
+		record.commit();
+		
+		this._panel.getStore().sort();
+	},
+	
+	/**
+	 * Handler function invoked whenever a {@link Ametys.message.Message.DELETED} message 
+	 * is sent out on the message bus. Delete the corresponding record from the grid panel's store.
+	 * @param {Ametys.message.Message} message the message
+	 */
+	_onDeleted: function (message)
+	{
+		var target = message.getTarget(Ametys.message.MessageTarget.DATASOURCE);
+		if (target)
+		{
+			var id = target.getParameters().id;
+			var datasource = this._panel.getStore().getById(target.getParameters().id);
+			if (datasource)
+			{
+				this._panel.getStore().remove(datasource);
+			}
+		}
+	}
+});
Index: main/plugin-admin/resources/js/Ametys/plugins/admin/datasource/DeleteDataSourceController.js
===================================================================
--- main/plugin-admin/resources/js/Ametys/plugins/admin/datasource/DeleteDataSourceController.js	(revision 0)
+++ main/plugin-admin/resources/js/Ametys/plugins/admin/datasource/DeleteDataSourceController.js	(revision 0)
@@ -0,0 +1,43 @@
+/*
+ *  Copyright 2015 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+
+/**
+ * This class controls a ribbon button allowing to delete a data source
+ * @private
+ */
+Ext.define('Ametys.plugins.admin.datasource.DeleteDataSourceController', {
+	extend: 'Ametys.ribbon.element.ui.ButtonController',
+	
+	/**
+	 * @private
+	 * @property {String} _type the type of data source managed by this controller
+	 */
+	
+	constructor: function(config)
+	{
+		this._type = config.type;
+		this.callParent(arguments);
+	},
+	
+	updateState: function()
+	{
+		var targets = this.getMatchingTargets();
+		if (targets.length > 0)
+		{
+			this.setDisabled(targets[0].getParameters().type != this._type);
+		}
+	}
+});
Index: main/plugin-admin/resources/js/Ametys/plugins/admin/datasource/EditLDAPDataSourceHelper.js
===================================================================
--- main/plugin-admin/resources/js/Ametys/plugins/admin/datasource/EditLDAPDataSourceHelper.js	(revision 0)
+++ main/plugin-admin/resources/js/Ametys/plugins/admin/datasource/EditLDAPDataSourceHelper.js	(revision 0)
@@ -0,0 +1,396 @@
+/*
+ *  Copyright 2015 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+
+/**
+ * Helper for the edition of a SQL data source
+ * @private
+ */
+Ext.define('Ametys.plugins.admin.datasource.EditLDAPDataSourceHelper', {
+	singleton: true,
+	
+	/**
+	 * @private
+	 * @property {Boolean} _initialized True if the dialog box creation process is finished
+	 */
+	/**
+	 * @private
+	 * @property {String} _mode The current edition mode ('new' or 'edit')
+	 */
+	/**
+	 * @private
+	 * @property {Ametys.window.DialogBox} _box The dialog box
+	 */
+	/**
+	 * @private
+	 * @property {Ext.form.Panel} _form The form panel
+	 */
+	/**
+	 * @private
+	 * @property {Function} _callback the callback function
+	 */
+	
+	/**
+	 * Open dialog box to create a new LDAP data source
+	 * @param {Function} callback a callback function to invoke after the form is validated, can be null
+	 */
+	add: function (callback)
+	{
+		this._callback = callback;
+		this._mode = 'new';
+		this._open (null);
+	},
+	
+	/**
+	 * Open dialog box to edit a LDAP data source
+	 * @param {String} id the id of the selected data source
+	 */
+	edit: function (id)
+	{
+		this._mode = 'edit';
+		this._open (id);
+	},
+	
+	/**
+	 * @private
+	 * Show dialog box for LDAP data source edition
+	 * @param {String} id the id of the selected data source in 'edit' mode, null in 'new' mode
+	 */
+	_open: function (id)
+	{
+		var me = this;
+		function configureCallback (success)
+		{
+			if (success)
+			{
+				me._initForm (id);
+				me._box.show();
+			}
+		}
+		
+		// Create dialog box if needed
+		this._createDialogBox(configureCallback);
+	},
+	
+	/**
+	 * @private
+	 * Create the dialog box if it is not already the case
+	 * @param {Function} callback function invoked when the dialog box's drawing is finished
+	 */
+	_createDialogBox: function (callback)
+	{
+		if (!this._initialized)
+		{
+			this._form = Ext.create('Ametys.form.ConfigurableFormPanel', {
+				testURL: Ametys.getPluginDirectPrefix('admin') + '/datasource/test'
+			});
+			
+			this._box = Ext.create('Ametys.window.DialogBox', {
+				title: this._mode == 'new' ? "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_LDAP_ADD_TITLE'/>" : "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_LDAP_EDIT_TITLE'/>",
+				icon: Ametys.getPluginResourcesPrefix('admin') + '/img/datasource/' + (this._mode == 'new' ? 'add_16.png' : 'edit_16.png'),
+				
+				layout: 'fit',
+				width: 700,
+				items: [ this._form ],
+				
+				closeAction: 'hide',
+				buttons : [{
+					text: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_LDAP_OK'/>",
+					handler: Ext.bind(this._ok, this)
+				}, {
+					text: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_LDAP_CANCEL'/>",
+					handler: Ext.bind(function() {this._box.hide();}, this)
+				}]
+			});
+			
+			this._configureForm(callback);
+		}
+		else
+		{
+			this._box.setTitle(this._mode == 'new' ? "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_LDAP_ADD_TITLE'/>" : "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_LDAP_EDIT_TITLE'/>");
+			this._box.setIcon(Ametys.getPluginResourcesPrefix('admin') + '/img/datasource/' + (this._mode == 'new' ? 'add_16.png' : 'edit_16.png'));
+			callback(true);
+		}
+	},
+	
+	/**
+	 * @private
+	 * Callback for the form configuration process. Configures the {@link Ametys.form.ConfigurableFormPanel} of the dialog box
+	 * @param {Function} args.callback the callback function
+	 */
+	_configureForm: function(callback)
+	{
+		var configuration = {};
+		
+		// Enumerations
+		var authenticationMethodEnumeration = [];
+		var aliasDereferencingEnumeration = [];
+		
+		// Anonymous
+		authenticationMethodEnumeration.push({label: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCE_CORE_LDAP_CONFIG_AUTH_METHOD_ENUM_NONE'/>", value: 'none'});
+		// Simple
+		authenticationMethodEnumeration.push({label: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCE_CORE_LDAP_CONFIG_AUTH_METHOD_ENUM_SIMPLE'/>", value: 'simple'});
+		
+		// Always
+		aliasDereferencingEnumeration.push({label: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCE_CORE_LDAP_CONFIG_ALIAS_DEREF_ENUM_NEVER'/>", value: 'never'});
+		// Never
+		aliasDereferencingEnumeration.push({label: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCE_CORE_LDAP_CONFIG_ALIAS_DEREF_ENUM_ALWAYS'/>", value: 'always'});
+		// Finding
+		aliasDereferencingEnumeration.push({label: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCE_CORE_LDAP_CONFIG_ALIAS_DEREF_ENUM_FINDING'/>", value: 'finding'});
+		// Searching
+		aliasDereferencingEnumeration.push({label: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCE_CORE_LDAP_CONFIG_ALIAS_DEREF_ENUM_SEARCHING'/>", value: 'searching'});
+		
+		
+		// Id field
+		configuration.id = {
+			hidden: true,
+			type: 'string'
+		};
+		
+		// Type field
+		configuration.type = {
+			hidden: true,
+			type: 'string',
+			'default-value': 'LDAP'
+		};
+		
+		// Name field
+		configuration.name = {
+			type: 'string',
+	        label: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_LDAP_FIELD_NAME'/>",
+	        description: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_LDAP_FIELD_NAME_DESCRIPTION'/>",
+	        validation: {
+	        	mandatory: true
+	        }
+		};
+		
+		// Description field
+		configuration.description = {
+			type: 'string',
+			widget: 'edition.textarea',
+			'widget-params': {
+				charCounter: false
+			},
+	        label: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_LDAP_FIELD_DESCRIPTION'/>",
+	        description: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_LDAP_FIELD_DESCRIPTION_DESCRIPTION'/>"
+		};
+		
+		// Base URL field 
+		configuration.baseURL = {
+			type: 'string',
+			label: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_LDAP_FIELD_URL'/>",
+			description: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_LDAP_FIELD_URL_DESCRIPTION'/>",
+			'default-value': 'ldap://server:389',
+	        validation: {
+	        	mandatory: true,
+	        	regexp: new RegExp('^ldaps?://[\\w\\-.]*(:\d+)?'),
+	        	regexText: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_LDAP_FIELD_URL_REGEXP_TEXT'/>"
+	        }
+		};
+		
+		// Use SSL field
+		configuration.useSSL = {
+			type: 'boolean',
+			widget: 'edition.checkbox',
+			label: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_LDAP_FIELD_USESSL'/>",
+			description: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_LDAP_FIELD_USESSL_DESCRIPTION'/>",
+	        validation: {
+	        	mandatory: true
+	        }
+		};
+
+		// Base DN field
+		configuration.baseDN = {
+			type: 'string',
+			label: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_LDAP_FIELD_BASEDN'/>",
+			description: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_LDAP_FIELD_BASEDN_DESCRIPTION'/>",
+			'default-value': 'dc=company,dc=com'
+		};
+		
+		// Alias dereferencing mode field
+		configuration.aliasDereferencing = {
+			type: 'string',
+			enumeration: aliasDereferencingEnumeration,
+			label: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_LDAP_FIELD_ALIASDEREFERENCING'/>",
+			description: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_LDAP_FIELD_ALIASDEREFERENCING_DESCRIPTION'/>",
+			'default-value': 'always'
+		};
+		
+		// Follow referrals field
+		configuration.followReferrals = {
+			type: 'boolean',
+			widget: 'edition.checkbox',
+			label: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_LDAP_FIELD_FOLLOWREFERRALS'/>",
+			description: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_LDAP_FIELD_FOLLOWREFERRALS_DESCRIPTION'/>"
+		};
+		
+		// Authentication method field
+		configuration.authenticationMethod = {
+			type: 'string',
+			enumeration: authenticationMethodEnumeration,
+			label: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_LDAP_FIELD_AUTHENTICATIONMETHOD'/>",
+			description: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_LDAP_FIELD_AUTHENTICATIONMETHOD_DESCRIPTION'/>",
+			'default-value': 'none'
+		};
+		
+		// Administrator domain name field
+		configuration.adminDN = {
+			type: 'string',
+			label: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_LDAP_FIELD_ADMINDN'/>",
+			description: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_LDAP_FIELD_ADMINDN_DESCRIPTION'/>",
+			disableCondition: {condition: [{id: 'authenticationMethod', operator: 'eq', value: 'none'}]},
+			'default-value': 'cn=admin'
+		};
+		
+		// Administrator password field
+		configuration.adminPassword = {
+			type: 'password',
+			widget: 'edition.password',
+			label: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_LDAP_FIELD_ADMINPASSWORD'/>",
+			description: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_LDAP_FIELD_ADMINPASSWORD_DESCRIPTION'/>",
+			disableCondition: {condition: [{id: 'authenticationMethod', operator: 'eq', value: 'none'}]}
+		};
+		
+		// Private field
+		configuration['private'] = {
+			type: 'boolean',
+			widget: 'edition.checkbox',
+			label: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_LDAP_FIELD_PRIVATE'/>",
+			description: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_LDAP_FIELD_PRIVATE_DESCRIPTION'/>",
+			'param-checker': {
+				id: 'sql-connection-checker-datasource',
+				'small-icon-path': '/plugins/admin/resources/img/datasource/test_ldapconnect_16.png',
+				'medium-icon-path': '/plugins/admin/resources/img/datasource/test_ldapconnect_32.png',
+				'large-icon-path': '/plugins/admin/resources/img/datasource/test_ldapconnect_48.png',
+				'linked-params': ['baseURL', 'baseDN', 'authenticationMethod', 'adminDN', 'adminPassword', 'useSSL', 'followReferrals'],
+				'param-ref': 'private',
+				label: "<i18n:text i18n:key='PLUGINS_CORE_LDAP_CONNECTION_CHECKER_LABEL' i18n:catalogue='plugin.core-impl'/>",
+				description: "<i18n:text i18n:key='PLUGINS_CORE_LDAP_CONNECTION_CHECKER_DESC' i18n:catalogue='plugin.core-impl'/>",
+				order: 1
+			}
+		};
+		
+		this._form.configure(configuration);
+		callback(true);
+	},
+	
+ 	/**
+ 	 * @private
+ 	 * Initialize the fields of the form
+ 	 * @param {String} id the id of the data source if in 'edit' mode, null in 'new' mode
+ 	 */
+	_initForm: function (id)
+ 	{
+		var form = this._form.getForm();
+		
+		// Reset the parameter checker status to 'not tested' and reset the warnings
+		if (this._initialized)
+		{
+			this._form.reset();
+		}
+		
+		this._initialized = true;
+		
+ 		if (id == null) 
+        {
+ 			// FIXME chrome automatically sets the user and password fields...
+ 			this._form.setValues({});
+ 			form.reset();
+        }
+ 		else
+ 		{
+ 			Ametys.plugins.admin.datasource.DataSourceDAO.getLDAPDataSource([id], this._setValues, {scope: this});
+ 			form.findField('id').setValue(id);
+ 		}
+ 	},
+
+ 	
+ 	/**
+ 	 * @private
+ 	 * Fill the edition form with the given values
+ 	 * @param {Object} datasource the parameter values for the sql data source
+ 	 * @param {String} datasource.name the name of the data source
+ 	 * @param {String} datasource.description the optional description of the data source
+ 	 * @param {String} datasource.baseURL the url of the LDAP server
+ 	 * @param {Boolean} datasource.useSSL is the connection using the 'ldaps' protocol ?
+ 	 * @param {String} datasource.baseDN the base domain name
+ 	 * @param {String} datasource.aliasDerefencing the mode for alias dereferencing
+ 	 * @param {Boolean} datasource.followReferrals true to follow the referrals
+	 * @param {String} datasource.authenticationMethod the authentication method used to establish a connection with the data source
+	 * @param {String} datasource.adminDN the administrator domain name
+	 * @param {String} datasource.adminPassword the administrator's password
+	 * @param {Boolean} datasource.private is the data source public or private ?
+ 	 */
+ 	_setValues: function(datasource)
+ 	{
+ 		this._form.setValues({values: datasource});
+ 	},
+ 	
+ 	/**
+ 	 * @private
+ 	 * Check if the data source is valid
+ 	 */
+ 	_ok: function()
+ 	{
+ 		if (!this._form.isValid())
+		{
+ 			return;
+		}
+ 		
+ 		// Test the data source
+ 		var paramCheckersDAO = this._form._paramCheckersDAO;
+ 		
+ 		Ext.getBody().mask("<i18n:text i18n:key='PLUGINS_CORE_UI_LOADMASK_DEFAULT_MESSAGE' i18n:catalogue='plugin.core-ui'/>");
+ 		paramCheckersDAO.check(paramCheckersDAO._paramCheckers,
+ 							   true, 
+					           Ext.bind(function(success) 
+				      		   { 
+					              Ext.getBody().unmask(); 
+					              if (success) 
+					              { 
+					            	  this._okCb();
+					              }
+				      	  		}, this), false); 
+ 	},
+ 	
+ 	/**
+ 	 * @private
+ 	 * Submit the form's values
+ 	 */
+	_okCb: function()
+	{
+		var values = this._form.getValues();
+ 		values['private'] = this._form.getForm().findField('private').getValue();
+ 		values['useSSL'] = this._form.getForm().findField('useSSL').getValue();
+ 		values['followReferrals'] = this._form.getForm().findField('followReferrals').getValue();
+ 		
+ 		if (this._mode == 'new')
+		{
+ 			Ametys.plugins.admin.datasource.DataSourceDAO.addLDAPDataSource([values], 
+				function(id) {
+ 					this._box.hide();
+ 			 		if (Ext.isFunction(this._callback))
+ 					{
+ 			 			this._callback(id);
+ 					}
+ 				}, 
+ 				{scope: this, waitMessage: {target: this._box}});
+		}
+ 		else
+		{
+ 			Ametys.plugins.admin.datasource.DataSourceDAO.editLDAPDataSource([values], function() {this._box.hide();}, {scope: this, waitMessage: {target: this._box}});
+		}
+	}
+});
\ No newline at end of file
